/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["docs.widget.CompoundViewer"]){
dojo._hasResource["docs.widget.CompoundViewer"]=true;
dojo.provide("docs.widget.CompoundViewer");
dojo.require("dojox.highlight");
dojo.require("dojox.highlight.languages._all");
dojo.require("dojox.layout.ContentPane");
dojo.require("docs.widget.CodeViewer");
dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("dijit.form.CheckBox");
dojo.declare("docs.widget.Blank",null,{});
dojo.declare("docs.widget.CompoundViewer",[dijit._Widget,dijit._Templated],{templateString:"<div dojoAttachPoint=\"outerNode\" class=\"compoundContainer\">\n\t<div class=\"themeSelector\" dojoAttachPoint=\"themeSelector\"></div>\n\t<div dojoAttachPoint=\"executedNode\"></div>\n\t<div dojoAttachPoint=\"contentNode\"></div>\n</div>\n",widgetsInTemplate:false,preview:{},createFullSource:true,themes:["tundra","nihilo","soria"],defaultTheme:"nihilo",dojoPath:"../../../../",def:{javascript:{displayCode:false,sourceCode:true},css:{displayCode:false,sourceCode:true},html:{displayCode:true,sourceCode:true}},hideCode:true,constructor:function(){
this.arrNodes=[];
this.arrExecuted=[];
this.arrViews=[];
},postMixInProperties:function(){
var el=this.srcNodeRef.firstChild;
var _1=[];
var _2={};
_2.content=[];
var _3=0;
while(el){
if(dojo.attr(el,"dojoType")!=null){
var _4="";
if(dojo.attr(el,"label")){
_4=dojo.attr(el,"label");
}
_2={"content":_2.content,"label":_4,"lang":el.lang,"code":el,"index":_3};
this.arrNodes[el.lang]=_2;
_2={"lang":"","content":[],"code":""};
el.removeAttribute("dojoType");
_3++;
}else{
_2.content.push(el);
}
el=el.nextSibling;
}
},postCreate:function(){
if(this.arrNodes.css){
this._executeCode("css");
this._buildCodeView("css");
}
if(this.arrNodes.javascript){
this._executeCode("javascript");
this._buildCodeView("javascript");
}
for(node in this.arrNodes){
this._buildCodeView(node);
}
if(this.preview.code){
var _5=dojo.doc.createElement("div");
dojo.addClass(_5,"compoundElement");
dojo.addClass(_5,"compoundPreview");
this.contentNode.appendChild(_5);
var _6=dojo.doc.createElement("div");
dojo.addClass(_6,"iconpreview");
_5.appendChild(_6);
var _7=dojo.doc.createElement("div");
var _8=dojo.doc.createElement("div");
_7.appendChild(_8);
_5.appendChild(_7);
_8.appendChild(this.preview.code);
dojo.connect(_6,"onclick",dojo.hitch(this,function(_9){
if(dojo.style(_9,"display")=="none"){
dojo.style(_9,"display","");
}else{
dojo.style(_9,"display","none");
}
},_7));
dojo.forEach(this.themes,function(_a){
this[_a+"_themeSelector"]=new dijit.form.RadioButton({name:this.id+"_ThemeSelector",id:_a+"_"+this.id+"_themeSelector"});
var _b=dojo.doc.createElement("label");
dojo.attr(_b,"for",_a+"_"+this.id+"_themeSelector");
_b.innerHTML=_a;
dojo.connect(this[_a+"_themeSelector"],"onClick",this,function(e){
(function(_c,_d){
window.location="?t="+_c.id.split("_")[0];
})(this[_a+"_themeSelector"],this);
});
this.themeSelector.appendChild(this[_a+"_themeSelector"].domNode);
this.themeSelector.appendChild(_b);
},this);
this.setTheme();
}
dojo.forEach(this.arrViews,function(_e){
var _f=dojo.doc.createElement("div");
dojo.addClass(_f,"compoundElement");
this.contentNode.appendChild(_f);
var _10=dojo.doc.createElement("div");
dojo.addClass(_10,"icon"+_e.type);
_f.appendChild(_10);
var _11=dojo.doc.createElement("div");
_f.appendChild(_11);
if(this.hideCode){
dojo.style(_11,"display","none");
}
dojo.connect(_10,"onclick",dojo.hitch(this,function(_12){
if(dojo.style(_12,"display")=="none"){
dojo.style(_12,"display","");
}else{
dojo.style(_12,"display","none");
}
},_11));
if(_e.label){
var _13=dojo.doc.createElement("h3");
_13.innerHTML=_e.label;
dojo.addClass(_13,"compoundLabel");
_11.appendChild(_13);
}
if(_e.content){
var _14=dojo.doc.createElement("div");
dojo.addClass(_14,"compoundText");
dojo.forEach(_e.content,function(_15){
_14.appendChild(_15);
},this);
_11.appendChild(_14);
}
dojo.addClass(_e.code.domNode,"compoundCode");
_11.appendChild(_e.code.domNode);
},this);
if(this.createFullSource){
this._buildFullSource();
}
if(_8){
var _16=new docs.widget.CodeViewer({codeClass:"html",displayCode:true,sourceCode:false,sourceIsOpen:true},_8);
}
delete this.arrNodes;
},setTheme:function(){
this[this.defaultTheme+"_themeSelector"].attr("checked",true);
if(window.location.href.indexOf("?")>-1){
var str=window.location.href.substr(window.location.href.indexOf("?")+1).split(/#/);
var ary=str[0].split(/&/);
for(var i=0;i<ary.length;i++){
var _17=ary[i].split(/=/),key=_17[0],_18=_17[1];
switch(key){
case "t":
dojo.attr(dojo.byId("themeCss"),"href",this.dojoPath+"dijit/themes/"+_18+"/"+_18+".css");
dojo.body().className=_18;
this[_18+"_themeSelector"].attr("checked",true);
break;
}
}
}
},_executeCode:function(_19){
var _1a=dojo.doc.createElement("div");
this.executedNode.appendChild(_1a);
var ret,_1b=document.createElement("textarea");
if(dojo.isIE){
_1b.innerText=dojo.query("pre",this.arrNodes[_19].code)[0].innerText;
}else{
_1b.innerHTML=dojo.query("pre",this.arrNodes[_19].code)[0].innerHTML;
}
ret=_1b.value;
this.arrExecuted[_19]=new dojox.layout.ContentPane({"class":"codeHidden",renderStyles:"true"},_1a);
this.arrExecuted[_19].attr("content",ret);
this.arrExecuted[_19].onLoadDeferred.addCallback(dojo.hitch(this,function(){
dojo.addOnLoad(dojo.hitch(this,function(){
dojo.parser.parse(this.arrExecuted[_19].domNode);
}));
}));
},_buildCodeView:function(_1c){
if(_1c=="html"){
this.preview.code=this.arrNodes[_1c].code;
this.def.html.displayCode=false;
}
var _1d=dojo.doc.createElement("div");
_1d.appendChild(dojo.clone(this.arrNodes[_1c].code));
var a=this.arrViews[this.arrNodes[_1c].index]=[];
a.type=_1c;
a.label=this.arrNodes[_1c].label;
a.content=this.arrNodes[_1c].content;
a.code=new docs.widget.CodeViewer({codeClass:_1c,displayCode:this.def[_1c].displayCode,sourceCode:this.def[_1c].sourceCode,sourceIsOpen:true},_1d);
},_buildFullSource:function(){
var _1e=["<html>","<head>","<title>Dojo example</title>","<style type=\"text/css\">","  @import \"pathtodojo/dijit/themes/nihilo/nihilo.css\";","</style>","${extraCSS}","<script type=\"text/javascript\" src=\"pathtodojo/dojo/dojo.js\" djConfig=\"parseOnLoad:true, isDebug: true\"></script>","${extraJs}","<body class=\"nihilo\">","${extraHTML}","</body>","</html>"].join("\n");
messages=[];
messages.extraCSS="";
messages.extraJs="";
messages.extraHTML="";
if(this.arrNodes.css&&this.arrNodes.css.code){
var ret,_1f=dojo.doc.createElement("textarea");
if(dojo.isIE){
_1f.innerText=dojo.query("pre",this.arrNodes.css.code)[0].innerText;
}else{
_1f.innerHTML=dojo.query("pre",this.arrNodes.css.code)[0].innerHTML;
}
ret=_1f.value;
messages.extraCSS=ret;
}
if(this.arrNodes.javascript&&this.arrNodes.javascript.code){
var ret,_1f=dojo.doc.createElement("textarea");
if(dojo.isIE){
_1f.innerText=dojo.query("pre",this.arrNodes.javascript.code)[0].innerText;
}else{
_1f.innerHTML=dojo.query("pre",this.arrNodes.javascript.code)[0].innerHTML;
}
ret=_1f.value;
messages.extraJs=ret;
}
if(this.arrNodes.html&&this.arrNodes.html.code){
var ret,_1f=dojo.doc.createElement("textarea");
if(dojo.isIE){
_1f.innerText=dojo.query("pre",this.arrNodes.html.code)[0].innerText;
}else{
_1f.innerHTML=dojo.query("pre",this.arrNodes.html.code)[0].innerHTML;
}
ret=_1f.value;
messages.extraHTML=ret;
}
var _1e=dojo.string.substitute(_1e,messages);
var _20=dojo.doc.createElement("div");
dojo.addClass(_20,"compoundElement");
this.contentNode.appendChild(_20);
var _21=dojo.doc.createElement("div");
dojo.addClass(_21,"iconcode");
_20.appendChild(_21);
var _22=dojo.doc.createElement("div");
_20.appendChild(_22);
if(this.hideCode){
dojo.style(_22,"display","none");
}
dojo.connect(_21,"onclick",dojo.hitch(this,function(_23){
if(dojo.style(_23,"display")=="none"){
dojo.style(_23,"display","");
}else{
dojo.style(_23,"display","none");
}
},_22));
var _24=dojo.doc.createElement("h3");
_24.innerHTML="Copy the full source";
dojo.addClass(_24,"compoundLabel");
_22.appendChild(_24);
var _25=dojo.doc.createElement("div");
dojo.addClass(_25,"compoundText");
var _26=dojo.doc.createElement("textarea");
dojo.attr(_26,"rows",10);
dojo.attr(_26,"cols",100);
_26.value=_1e;
_25.appendChild(_26);
_22.appendChild(_25);
}});
}
